SystemOrganization addCategory: #'tODE-Views'!

TOView subclass: #TOInspector
	instanceVariableNames: 'basicInspect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOInspector methodsFor: 'private' stamp: 'dkh 5/22/2011 12:25'!
basicFieldsFor: anObject

	(Pragma allNamed: #tODEBasicInspectorFields from: self object class to: nil) do: [:pragma |
		^self object perform: pragma method selector ].
	^#()! !

!TOInspector methodsFor: 'accessing' stamp: 'dkh 5/22/2011 11:37'!
basicInspect

	basicInspect ifNil: [ basicInspect := false ].
	^basicInspect! !

!TOInspector methodsFor: 'accessing' stamp: 'dkh 5/22/2011 11:19'!
basicInspect: aBool

	basicInspect := aBool! !

!TOInspector methodsFor: 'private' stamp: 'dkh 5/22/2011 12:21'!
fieldsFor: anObject

	(Pragma allNamed: #tODEInspectorFields from: self object class to: nil) do: [:pragma |
		^self object perform: pragma method selector ].
	^#()! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/22/2011 18:41'!
renderBasicToggleOn: html main: main
	| members |
	self basicInspect
		ifTrue: [ 
			members := self basicFieldsFor: self object.
			self
				renderLink: [ :s | 
					self basicInspect: false.
					main updateCenterOn: s ]
				with: 'toggle inspector'
				on: html.
			self renderFrameLinkOn: html main: main ]
		ifFalse: [ 
			members := self fieldsFor: self object.
			members isEmpty
				ifTrue: [ 
					members := self basicFieldsFor: self object.
					members isEmpty
						ifTrue: [ 
							self renderFrameLinkOn: html main: main.
							html text: (self object printStringLimitedTo: 50).
							^ #() ].
					self renderFrameLinkOn: html main: main ]
				ifFalse: [ 
					self
						renderLink: [ :s | 
							self basicInspect: true.
							main updateCenterOn: s ]
						with: 'toggle basic inspector'
						on: html ] ].
	html break; break.
	^ members! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/22/2011 18:39'!
renderContentOn: html main: main

	| members |
	self renderClassHeading: self actualClass on: html main: main.
	html break.
	members := self renderBasicToggleOn: html main: main.
	self renderMembers: members on: html main: main! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/22/2011 18:41'!
renderFrameLinkOn: html main: main
	html break.
	self
		renderLink: [ :s | 
			| frame |
			frame := main currentSpace push: main currentFrame.
			frame selectedCenterTab: #inspect.
			main updateCenterSideHistory: s ]
		with: '(frame)'
		on: html.
! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/22/2011 17:45'!
renderMembers: members on: html main: main
	members
		do: [ :assoc | 
			self
				renderLink: [ :s | 
					| frame |
					frame := main currentSpace push: assoc value.
					frame selectedCenterTab: #inspect.
					main updateCenterSideHistory: s ]
				with: assoc key
				on: html.
			html text: ' -> ' , (assoc value printStringLimitedTo: 50).
			html break ]! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/22/2011 12:34'!
renderClassTabOn: html frame: frame tOdeMain: main! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/22/2011 16:43'!
renderHelpTabOn: html frame: frame tOdeMain: main
	self isBehavior
		ifTrue: [ 
			(html heading)
				level: 3;
				with: 'I am the Class ', self name.
			html preformatted: self comment ]
		ifFalse: [ 
			(html heading)
				level: 3;
				with: 'I am an instance of ', self class name.
			html preformatted: self class comment ]	! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/22/2011 12:35'!
renderInspectorTabOn: html frame: frame tOdeMain: main
	(frame properties 
		at: #inspector 
		ifAbsent: [ frame properties at: #inspector put: (TOInspector new object: self) ])
			renderContentOn: html
			main: main! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/22/2011 12:34'!
renderMethodTabOn: html frame: frame tOdeMain: main! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/22/2011 12:25'!
tODEBasicInspectorFields
	<tODEBasicInspectorFields>
	| members |
	members := WriteStream on: Array new.
	self class allInstVarNames 
		keysAndValuesDo: [ :index :each | members nextPut: each -> (self instVarAt: index) ].
	self class isVariable
		ifTrue: [ 1 to: self basicSize do: [ :index | members nextPut: index -> (self basicAt: index) ] ].
	^ members contents! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/22/2011 12:35'!
tODEClassTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #classBrowser;
		label: 'class';
		order: 25;
		group: 'development';
		renderSelector: #renderClassTabOn:frame:tOdeMain:! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/22/2011 12:36'!
tODEHelpTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #help;
		label: 'help';
		order: 25;
		group: 'basic';
		renderSelector: #renderHelpTabOn:frame:tOdeMain:! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/22/2011 12:36'!
tODEInspectorTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #inspect;
		label: 'inspect';
		order: 50;
		group: 'basic';
		renderSelector: #renderInspectorTabOn:frame:tOdeMain:! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/22/2011 12:35'!
tODEMethodTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #methodBrowser;
		label: 'method';
		order: 50;
		group: 'development';
		renderSelector: #renderMethodTabOn:frame:tOdeMain:! !
